--[[
	Capship Tab written by Seryn
	version 1.5.0 public
	based on mdi-targetlist tab system by draugath
--]]

declare("Capship_tab", {
	version = "1.5.0",
})


local T = {
	Tab = {
		title = "Capship",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Commands",
				width = 1,
			},
		},
		filters = {
			{
				title = "Commands",
				pages = {
					{
						title = "CMD",
						fgcolor = "235 52 88 225 *",
						bgcolor = "52 116 235 225 *",
					},	
					{
						title = "PVE",
						fgcolor = "52 192 235 225 *",
						bgcolor = "34 49 163 225 *",
					},
				},
			},
			{
				title = "Features",
			},
			{
				title = "Turrets",
			},
			{
				title = "Ships",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Capship_tab.T = T
T.Tab.mainCommandList = {
	{
		"1",
		"\12759a5d8** Follow ME",
	},
	{
		"2",
		"\12750b8cf** Follow Target",
	},
	{ 
		"3",
		"\12773c7bd** Park",
	},
	{	
		"4",
		"\127a2d1b0** Turbo",
	},
	{	
		"5",
		"\127ced8b0** Shield",
	},
	{	
		"6",
		"\127f3dfbf** Attack Target",
	},
	{	
		"7",
		"\127a2d1b0** Defend Target",
	},
	{	
		"8",
		"\12773c7bd** Patrol",
	},
	{	
		"9",
		"\12750b8cf** Cease Fire",
	}
}
T.Tab.pveCommandList = {
	{
		"1",
		"\12759a5d8** Follow ME",
	},
	{
		"2",
		"\12750b8cf** Follow Target",
	},
	{ 
		"3",
		"\12773c7bd** Park",
	},
	{	
		"4",
		"\127a2d1b0** Prepare for docking",
	},
	{	
		"5",
		"\127ced8b0** Mine",
	},
	{	
		"6",
		"\127f3dfbf** Gather Target Ore",
	},
}
T.Tab.featuresList = {
	{
		"1",
		"\12759a5d8** Autocontrol on docking ON/OFF",
	},
	{
		"2",
		"\12750b8cf** Switch Control Trident/Goliath",
	},
	{
		"3",
		"\12773c7bd** Give Capship Key",
	},
	{ 
		"4",
		"\127a2d1b0** Revoke Capship Key",
	},
	{	
		"5",
		"\127ced8b0** Plot Route to Capship",
	},
	{	
		"6",
		"\127f3dfbf** Kick All Gunners",
	},
	{	
		"7",
		"\127a2d1b0** Dismiss All Gunners",
	},
	
	
}
T.Tab.turretList = {
	{	
		"1",
		"\12759a5d8** Enable/Disable Turret 1",
	},
	{	
		"2",
		"\12750b8cf** Enable/Disable Turret 2",
	},
	{	
		"3",
		"\12773c7bd** Enable/Disable Turret 3",
	},
	{	
		"4",
		"\127a2d1b0** Enable/Disable Turret 4",
	},
	{	
		"5",
		"\127ced8b0** Enable/Disable ALL Turrets",
	},
	{	
		"6",
		"\127f3dfbf** Enable/Disable MISSILE Turrets",
	},
	{	
		"7",
		"\127a2d1b0** Enter Turret 1",
	},
	{	
		"8",
		"\12773c7bd** Enter Turret 2",
	},
	{	
		"9",
		"\12750b8cf** Enter Turret 3",
	},
	{	
		"10",
		"\12759a5d8** Enter Turret 4",
	},
}
T.Tab.shipsList = {
	{	
		"1",
		"\12759a5d8** Undock Ship 1",
	},
	{	
		"2",
		"\12750b8cf** Undock Ship 2",
	},
	{	
		"3",
		"\12773c7bd** Undock Ship 3",
	},
	{	
		"4",
		"\127a2d1b0** Undock Ship 4",
	},
	{	
		"5",
		"\127ced8b0** Undock Ship 5",
	},
	{	
		"6",
		"\127f3dfbf** Undock Ship 6",
	},
}

T.Tab.ship = {}
T.Tab.ship.tridentName = " "
T.Tab.ship.goliathName = " "
T.Tab.ship.tridentKey = " "
T.Tab.ship.goliathKey = " "
T.Tab.ship.controlTrident = true
T.Tab.ship.controlGoliath = false
T.Tab.ship.autocontrolCapship = false
T.Tab.ship.turretDisabled1 = false
T.Tab.ship.turretDisabled2 = false
T.Tab.ship.turretDisabled3 = false
T.Tab.ship.turretDisabled4 = false
T.Tab.ship.turretDisabledALL = false
T.Tab.ship.turretDisabledMISSILE = false
T.Tab.ship.shieldNotifyMode = "0"
T.Tab.sendTimer = Timer()
T.Tab.systemnotes = 1120003470

local pCommand = gkinterface.GKProcessCommand


dofile("capfunctions.lua")	
dofile("config.lua")


-- tab change to capship tab, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	T.Tab.filter_page = page
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.currentList = T.Tab.mainCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.currentList = T.Tab.pveCommandList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.featuresList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.turretList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 4 then
		T.Tab.currentList = T.Tab.shipsList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end

-- 
function T.Tab:ChangeTarget(oldListID, newListID, selector)
	
	local listEntryID = newListID
	local oldListID = oldListID or 1
	local selectMode = selector
	
	if self.filter_index == 1 and self.filter_page == 1 then

		-- switch between linked and unlinked mode
		if selectMode == true then 
			-- T.Tab.currentList[listEntryID].highlight = "select"
			-- if item is activated twice
			if (oldListID == listEntryID) then 
				T.Tab.currentList[listEntryID].highlight = true
			-- don't change highlight if the selector is the active item
			elseif (listEntryID == targetlist.API.GetActiveItemIndex(self)) then
				T.Tab.currentList[listEntryID].highlight = true
			-- else highlight set to select 
			else
                T.Tab.currentList[listEntryID].highlight = "select" 

            end
			-- if the old highlight is the selector, don't change anything
            if (oldListID == targetlist.API.GetActiveItemIndex(self)) then
                -- do nothing
			-- else unhighlight the old list item
            elseif (oldListID and oldListID ~= listEntryID) then
                T.Tab.currentList[oldListID].highlight = nil
            end

		-- linked mode, highlight to true, no selectors
		else
			-- /msg shipname follow
			if listEntryID == 1 then
				Capship_tab.T.Tab.capFollow()

			-- /msg shipname follow targetname
			elseif listEntryID == 2 then
				Capship_tab.T.Tab.capFollowTarget()

			-- /msg shipname park
			elseif listEntryID == 3 then
				Capship_tab.T.Tab.capPark()

			-- /msg shipname turbo
			elseif listEntryID == 4 then
				Capship_tab.T.Tab.capTurbo()

			-- /msg shipname shield
			elseif listEntryID == 5 then
				Capship_tab.T.Tab.capShields()

			-- /msg shipname attack targetname
			elseif listEntryID == 6 then
				Capship_tab.T.Tab.capAttack()

			-- /msg shipname defend targetname
			elseif listEntryID == 7 then
				Capship_tab.T.Tab.capDefend()

			-- /msg shipname patrol
			elseif listEntryID == 8 then
				Capship_tab.T.Tab.capPatrol()

			-- /msg shipname cease fire
			elseif listEntryID == 9 then
				Capship_tab.T.Tab.capCeaseFire()

			--
			elseif listEntryID == 10 then
				return
			end


			-- remove old highlight and highlight new item
			T.Tab.currentList[oldListID].highlight = nil
			T.Tab.currentList[listEntryID].highlight = true
		end 
		-- update the display to see the changes
		targetlist.API.UpdateDisplay(self, self.currentList)

	-- pve tab
	elseif self.filter_index == 1 and self.filter_page == 2 then
		
		-- switch between linked and unlinked mode
		if selectMode == true then 
			-- T.Tab.currentList[listEntryID].highlight = "select"
			-- if item is activated twice
			if (oldListID == listEntryID) then 
				T.Tab.currentList[listEntryID].highlight = true
			-- don't change highlight if the selector is the active item
			elseif (listEntryID == targetlist.API.GetActiveItemIndex(self)) then
				T.Tab.currentList[listEntryID].highlight = true
			-- else highlight set to select 
			else
                T.Tab.currentList[listEntryID].highlight = "select" 

            end
			-- if the old highlight is the selector, don't change anything
            if (oldListID == targetlist.API.GetActiveItemIndex(self)) then
                -- do nothing
			-- else unhighlight the old list item
            elseif (oldListID and oldListID ~= listEntryID) then
                T.Tab.currentList[oldListID].highlight = nil
            end

		-- linked mode, highlight to true, no selectors
		else
		
			-- /msg shipname follow
			if listEntryID == 1 then
				Capship_tab.T.Tab.capFollow()

			-- /msg shipname follow targetname
			elseif listEntryID == 2 then
				Capship_tab.T.Tab.capFollowTarget()

			-- /msg shipname park
			elseif listEntryID == 3 then
				Capship_tab.T.Tab.capPark()

			-- /msg shipname prepare for docking
			elseif listEntryID == 4 then
				Capship_tab.T.Tab.capPrepareDocking()

			-- /msg shipname mine
			elseif listEntryID == 5 then
				Capship_tab.T.Tab.capMine()

			-- /msg shipname gather targetore
			elseif listEntryID == 6 then
				Capship_tab.T.Tab.capGather()

			elseif listEntryID == 7 then
				return

			elseif listEntryID == 8 then
				return

			elseif listEntryID == 9 then
				return

			elseif listEntryID == 10 then
				return
			end

			-- remove old highlight and highlight new item
			T.Tab.currentList[oldListID].highlight = nil
			T.Tab.currentList[listEntryID].highlight = true
		end 
		-- update the display to see the changes
		targetlist.API.UpdateDisplay(self, self.currentList)


	-- management tab
	elseif self.filter_index == 2 then
		
		-- switch between linked and unlinked mode
		if selectMode == true then 
			-- T.Tab.currentList[listEntryID].highlight = "select"
			-- if item is activated twice
			if (oldListID == listEntryID) then 
				T.Tab.currentList[listEntryID].highlight = true
			-- don't change highlight if the selector is the active item
			elseif (listEntryID == targetlist.API.GetActiveItemIndex(self)) then
				T.Tab.currentList[listEntryID].highlight = true
			-- else highlight set to select 
			else
                T.Tab.currentList[listEntryID].highlight = "select" 
            end
			-- if the old highlight is the selector, don't change anything
            if (oldListID == targetlist.API.GetActiveItemIndex(self)) then
                -- do nothing
			-- else unhighlight the old list item
            elseif (oldListID and oldListID ~= listEntryID) then
                T.Tab.currentList[oldListID].highlight = nil
            end

		-- linked mode, highlight to true, no selectors
		else
			
			-- autocontrol when docking
			if listEntryID == 1 then
				Capship_tab.T.Tab.autocontrolCapship()

			-- switch between capships to control via the capship tab
			elseif listEntryID == 2 then
				Capship_tab.T.Tab.switchCapship()

			-- give user key to target
			elseif listEntryID == 3 then
				Capship_tab.T.Tab.giveKey()

			-- revoke user key of target
			elseif listEntryID == 4 then
				Capship_tab.T.Tab.revokeKey()

			-- plot to your capship
			elseif listEntryID == 5 then
				Capship_tab.T.Tab.findCapship()

			-- kick all gunners
			elseif listEntryID == 6 then
				Capship_tab.T.Tab.kickGunners()

			-- dismiss all gunners
			elseif listEntryID == 7 then
				Capship_tab.T.Tab.dismissGunners()

			-- shield notifcation mode
			elseif listEntryID == 8 then
				return
			-- 
			elseif listEntryID == 9 then
				return
			--
			elseif listEntryID == 10 then
				return
			end

			-- remove old highlight and highlight new item
			T.Tab.currentList[oldListID].highlight = nil
			T.Tab.currentList[listEntryID].highlight = true
		end 
		-- update the display to see the changes
		targetlist.API.UpdateDisplay(self, self.currentList)

	-- turret options tab
	elseif self.filter_index == 3 then
		
		-- switch between linked and unlinked mode
		if selectMode == true then 
			-- T.Tab.currentList[listEntryID].highlight = "select"
			-- if item is activated twice
			if (oldListID == listEntryID) then 
				T.Tab.currentList[listEntryID].highlight = true
			-- don't change highlight if the selector is the active item
			elseif (listEntryID == targetlist.API.GetActiveItemIndex(self)) then
				T.Tab.currentList[listEntryID].highlight = true
			-- else highlight set to select 
			else
                T.Tab.currentList[listEntryID].highlight = "select" 
            end
			-- if the old highlight is the selector, don't change anything
            if (oldListID == targetlist.API.GetActiveItemIndex(self)) then
                -- do nothing
			-- else unhighlight the old list item
            elseif (oldListID and oldListID ~= listEntryID) then
                T.Tab.currentList[oldListID].highlight = nil
            end

		-- linked mode, highlight to true, no selectors
		else
		
			-- enable/disable turret 1
			if listEntryID == 1 then
				Capship_tab.T.Tab.enableTurret1()
				
			-- enable/disable turret 2
			elseif listEntryID == 2 then
				Capship_tab.T.Tab.enableTurret2()
				
			-- enable/disable turret 3
			elseif listEntryID == 3 then
				Capship_tab.T.Tab.enableTurret3()

			-- enable/disable turret 4
			elseif listEntryID == 4 then
				Capship_tab.T.Tab.enableTurret4()

			-- enable/disable ALL turrets
			elseif listEntryID == 5 then
				Capship_tab.T.Tab.enableTurretALL()

			-- enable/disable MISSILE turrets
			elseif listEntryID == 6 then
				Capship_tab.T.Tab.enableTurretMISSILE()

			-- enter turret 1
			elseif listEntryID == 7 then
				Capship_tab.T.Tab.enterTurret1()

			-- enter turret 2
			elseif listEntryID == 8 then
				Capship_tab.T.Tab.enterTurret2()

			-- enter turret 3
			elseif listEntryID == 9 then
				Capship_tab.T.Tab.enterTurret3()

			-- enter turret 4
			elseif listEntryID == 10 then
				Capship_tab.T.Tab.enterTurret4()
			end

			-- remove old highlight and highlight new item
			T.Tab.currentList[oldListID].highlight = nil
			T.Tab.currentList[listEntryID].highlight = true
		end 
		-- update the display to see the changes
		targetlist.API.UpdateDisplay(self, self.currentList)

	-- ship options tab
	elseif self.filter_index == 4 then

		-- switch between linked and unlinked mode
		if selectMode == true then 
			-- T.Tab.currentList[listEntryID].highlight = "select"
			-- if item is activated twice
			if (oldListID == listEntryID) then 
				T.Tab.currentList[listEntryID].highlight = true
			-- don't change highlight if the selector is the active item
			elseif (listEntryID == targetlist.API.GetActiveItemIndex(self)) then
				T.Tab.currentList[listEntryID].highlight = true
			-- else highlight set to select 
			else
                T.Tab.currentList[listEntryID].highlight = "select" 
            end
			-- if the old highlight is the selector, don't change anything
            if (oldListID == targetlist.API.GetActiveItemIndex(self)) then
                -- do nothing
			-- else unhighlight the old list item
            elseif (oldListID and oldListID ~= listEntryID) then
                T.Tab.currentList[oldListID].highlight = nil
            end

		-- linked mode, highlight to true, no selectors
		else
			-- undock first stored ship
			if listEntryID == 1 then
				Capship_tab.T.Tab.undockShip1()
				
			-- undock second stored ship
			elseif listEntryID == 2 then
				Capship_tab.T.Tab.undockShip2()
				
			-- undock third stored ship
			elseif listEntryID == 3 then
				Capship_tab.T.Tab.undockShip3()

			-- undock fourth stored ship
			elseif listEntryID == 4 then
				Capship_tab.T.Tab.undockShip4()

			-- undock fifth stored ship
			elseif listEntryID == 5 then
				Capship_tab.T.Tab.undockShip5()

			-- undock sixth stored ship
			elseif listEntryID == 6 then
				Capship_tab.T.Tab.undockShip6()

			-- 
			elseif listEntryID == 7 then
				return

			-- 
			elseif listEntryID == 8 then
				return

			-- 
			elseif listEntryID == 9 then
				return

			-- 
			elseif listEntryID == 10 then
				return

			end

			-- remove old highlight and highlight new item
			T.Tab.currentList[oldListID].highlight = nil
			T.Tab.currentList[listEntryID].highlight = true
		end 
		-- update the display to see the changes
		targetlist.API.UpdateDisplay(self, self.currentList)


	end
	
end






local chatreceiver_old = chatreceiver.OnEvent
function chatreceiver:OnEvent(event, data)
	if event == "CHAT_MSG_PRINT" then
		local msg = data.msg
		if msg == "<CLICK!> Out of missiles!" then
			HUD:PrintSecondaryMsg("\127ffff8c<CLICK!> Out of missiles!\127o")
		else
			chatreceiver_old(chatreceiver, event, data) 
		end
	elseif event == "CHAT_MSG_SECTORD" then
		local msg = data.msg
		if msg == "Turret Control Online" then
			HUD:PrintSecondaryMsg("\127ffff8cTurret Control Online\127o")

		elseif msg == "Turret Control Offline" then
			HUD:PrintSecondaryMsg("\127ffff8cTurret Control Offline\127o")
			
		else
			chatreceiver_old(chatreceiver, event, data) 
		end
	else
		chatreceiver_old(chatreceiver, event, data)
    end
end


-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 3) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\12750b8cfMDI-TargetList API version is not compatible. Capship Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\12750b8cfCapship Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end





RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
RegisterEvent(Capship_tab.T.Tab.autoControl, "ENTERED_STATION")


-- user commands to be used as separate keybinds, uncomment as necessary

RegisterUserCommand("capfollow", Capship_tab.T.Tab.capFollow)
RegisterUserCommand("capfollowtarget", Capship_tab.T.Tab.capFollowTarget)
RegisterUserCommand("cappark", Capship_tab.T.Tab.capPark)
RegisterUserCommand("capturbo", Capship_tab.T.Tab.capTurbo)
-- RegisterUserCommand("capshields", Capship_tab.T.Tab.capShields)
RegisterUserCommand("capattack", Capship_tab.T.Tab.capAttack)
-- RegisterUserCommand("capdefend", Capship_tab.T.Tab.capDefend)
-- RegisterUserCommand("cappatrol", Capship_tab.T.Tab.capPatrol)
-- RegisterUserCommand("capceasefire", Capship_tab.T.Tab.capCeaseFire)
-- RegisterUserCommand("capprepare", Capship_tab.T.Tab.capPrepareDocking)
RegisterUserCommand("capmine", Capship_tab.T.Tab.capMine)
-- RegisterUserCommand("capgather", Capship_tab.T.Tab.capGather)

-- RegisterUserCommand("autocontrol", Capship_tab.T.Tab.autocontrolCapship)
RegisterUserCommand("switchcapship", Capship_tab.T.Tab.switchCapship)
-- RegisterUserCommand("givekey", Capship_tab.T.Tab.giveKey)
-- RegisterUserCommand("revokekey", Capship_tab.T.Tab.revokeKey)
-- RegisterUserCommand("findcapship", Capship_tab.T.Tab.findCapship)
-- RegisterUserCommand("kickgunners", Capship_tab.T.Tab.kickGunners)
-- RegisterUserCommand("dismissgunners", Capship_tab.T.Tab.dismissGunners)

-- RegisterUserCommand("enableturret1", Capship_tab.T.Tab.enableTurret1)
-- RegisterUserCommand("enableturret2", Capship_tab.T.Tab.enableTurret2)
-- RegisterUserCommand("enableturret3", Capship_tab.T.Tab.enableTurret3)
-- RegisterUserCommand("enableturret4", Capship_tab.T.Tab.enableTurret4)
-- RegisterUserCommand("enableturretall", Capship_tab.T.Tab.enableTurretALL)
-- RegisterUserCommand("enableturretmissile", Capship_tab.T.Tab.enableTurretMISSILE)

RegisterUserCommand("undockship1", Capship_tab.T.Tab.undockShip1)
-- RegisterUserCommand("undockship2", Capship_tab.T.Tab.undockShip2)
-- RegisterUserCommand("undockship3", Capship_tab.T.Tab.undockShip3)
-- RegisterUserCommand("undockship4", Capship_tab.T.Tab.undockShip4)
-- RegisterUserCommand("undockship5", Capship_tab.T.Tab.undockShip5)
-- RegisterUserCommand("undockship6", Capship_tab.T.Tab.undockShip6)